{***********************************************************************
Unit gfx_FilterCtrl.PAS v1.0
    (c) by Andreas Moser, amoser@amoser.de,

    Delphi version : Delphi 4

    gfx_Filterctrl is part of the gfx_library collection

    You may use this sourcecode for your freewareproducts.
    You may modify this source-code for your own use.
    You may recompile this source-code for your own use.

    All functions, procedures and classes may NOT be used in commercial
    products without the permission of the author. For parts of this library
    which are not written by me, you have to ask for permission by their
    respective authors.


    Disclaimer of warranty: "This software is supplied as is. The author
    disclaims all warranties, expressed or implied, including, without
    limitation, the warranties of merchantability and of fitness for any
    purpose. The author assumes no liability for damages, direct or
    consequential, which may result from the use of this software."

    All brand and product names are marks or registered marks of their
    respective companies.

    Please report bugs to:
    Andreas Moser  amoser@amoser.de

********************************************************************************}
unit gfx_FilterCtrl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,gfx_basedef,gfx_effects,gfx_effectex,gfx_Rotresize,gfx_files, Mask, ExtDlgs,io_files,
  Histogram, ComCtrls, PreviewPanel, Buttons,vcl_tools;
type
  TFilterCtrlForm = class(TForm)
    Button3: TButton;
    PageControl1: TPageControl;
    UserSheet: TTabSheet;
    RadioGroup1: TRadioGroup;
    Panel1: TPanel;
    LinearSheet: TTabSheet;
    ListBox1: TListBox;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    cbIntensity: TCheckBox;
    RadioGroup2: TRadioGroup;
    Button1: TButton;
    TwoPassSheet: TTabSheet;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    FilterCombo1: TComboBox;
    FilterCombo2: TComboBox;
    FilterCombo3: TComboBox;
    FilterCombo4: TComboBox;
    TwoPass: TListBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Funct1: TComboBox;
    Funct2: TComboBox;
    Funct3: TComboBox;
    NrPass: TRadioGroup;
    DelLinear: TButton;
    NewLin: TButton;
    SaveLin: TButton;
    Label10: TLabel;
    Label11: TLabel;
    ListBox2: TListBox;
    MirrorTopBotCB: TCheckBox;
    MirrorLefRigCB: TCheckBox;
    MaskEdit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    MAskEdit2: TEdit;
    SpeedButton3: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Label12: TLabel;
    Shape2: TShape;
    OpenPictureDialog1: TOpenPictureDialog;
    PreviewPanel1: TPreviewPanel;
    Button5: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button6: TButton;
    Button7: TButton;
    procedure MakeEditFields(Filter:TGraphicFilter);
    procedure EditChanged(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure PreviewPanel1OrgPosChanged(Sender: TObject);
    procedure FilterCombo2Change(Sender: TObject);
    procedure Funct1Change(Sender: TObject);
    procedure NrPassClick(Sender: TObject);
    procedure NewLinClick(Sender: TObject);
    procedure SaveLinClick(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure RotateMatrix(Steps:Integer);
    procedure MirrorTopBotCBClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    ResultBitmap:TBitmap;
    { Public-Deklarationen }
  end;

var
  FilterCtrlForm: TFilterCtrlForm;
  EditArray:Array [0..48] of TEdit;
  ActFilter:TGraphicFilter;
  BckMatrix:TEffectMatrix;
  ActTwoPassFilter:TMultiPassGraphicFilter;
  r,g,b:Boolean;
  eMode:TColorSpace;

COnst TwoPassFilters: Array [1..cnt_predefined_multipass] of record
     Filter:^TMultiPassGraphicFilter;
     end =(
     (Filter:@nmxLaplacianInvert),
     (Filter:@nmxChurchPattern));

COnst LinearFilters: Array [1..cnt_predefined_linflt] of record
     Filter:^TGraphicFilter;
     end =(
     (Filter:@mxAverage),
     (Filter:@mxEdgesStrong),
     (Filter:@mxEdgesWeak),
     (Filter:@mxEdgeEnhance),
     (Filter:@mxEmbossColor),
     (Filter:@mxEmbossLight),
     (Filter:@mxEmbossMedium),
     (Filter:@mxEmbossDark),
     (Filter:@mxEtch),
     (Filter:@mxBlur),
     (Filter:@mxBlurSoftly),
     (Filter:@mxBlurMore),
     (Filter:@mxBlurBartlett),
     (Filter:@mxBlurGaussian),
     (Filter:@mxGlow),
     (Filter:@mxLaplacianHV),
     (Filter:@mxLaplacianOmni),
     (Filter:@mxMaximum),
     (Filter:@mxMinimum),
     (Filter:@mxMedian),
     (Filter:@mxNegative),
     (Filter:@mxPrewitt),
     (Filter:@mxSharpen),
     (Filter:@mxSharpenMore),
     (Filter:@mxSharpenLess),     
     (Filter:@mxSharpenDirectional),     
     (Filter:@mxSobelPass),
     (Filter:@mxUnSHarpMask),
     (Filter:@mxTraceContour),
     (Filter:@mxWaggle),
     (Filter:@mxPattern),
     (Filter:@mxZero));

const Functions:Array[0..10] of string =
      ('None',
       'Add',
       'Substract',
       'Multiply',
       'Divide',
       'Darkest',
       'Lightest',
       'Difference',
       'Binary Or',
       'Binary And',
       'Average');

implementation


{$R *.DFM}

procedure TFilterCtrlForm.MakeEditFields(Filter:TGraphicFilter);
var i:Integer;
begin
  for i:=0 to 48 do
  begin
     case Filter.MatrixSize of
     mx3: if ((i div 7) in [2..4]) and ((i mod 7) in [2..4])
           then EditArray[i].Visible:=true else EditArray[i].Visible:=false;
     mx5:if ((i div 7) in [1..5]) and ((i mod 7) in [1..5])
           then EditArray[i].Visible:=true else EditArray[i].Visible:=false;
     mx7:if ((i div 7) in [0..6]) and ((i mod 7) in [0..6])
           then EditArray[i].Visible:=true else EditArray[i].Visible:=false;
     end;
     if MirrorTopBotCB.Checked and MirrorLefRigCB.Checked then
     begin
       if ((i Div 7) in [4..6])or ((i mod 7) in [4..6]) then
       begin
         EditArray[i].Enabled:=false;
         if ((i Div 7) in [4..6]) then Filter.Matrix[i div 7,i mod 7]:=Filter.Matrix[i div 7-(((i div 7)-3)*2),i mod 7];
         if ((i mod 7) in [4..6]) then Filter.Matrix[i div 7,i mod 7]:=Filter.Matrix[i div 7,i mod 7-(((i mod 7)-3)*2) ];
       end
       else EditArray[i].Enabled:=true;
     end
     else
     if MirrorTopBotCB.Checked then
     begin
       if ((i mod 7) in [4..6])  then begin
          EditArray[i].Enabled:=false;
          Filter.Matrix[i div 7,i mod 7]:=Filter.Matrix[i div 7,i mod 7-(((i mod 7)-3)*2) ];
       end
       else EditArray[i].Enabled:=true;
     end
     else
     if MirrorLefRigCB.Checked then
     begin
       if ((i div 7) in [4..6])  then begin
         EditArray[i].Enabled:=false;
         Filter.Matrix[i div 7,i mod 7]:=Filter.Matrix[i div 7-(((i div 7)-3)*2),i mod 7];
       end
       else EditArray[i].Enabled:=true;
     end
     else EditArray[i].Enabled:=true;


     EditArray[i].Text:=IntToStr(Filter.Matrix[i div 7,i mod 7]);

  end;
     MaskEdit1.Text:=IntToStr(Filter.Divisor);
     MaskEdit2.Text:=IntToStr(Filter.Bias);
     RadioGroup1.ItemIndex:=Integer(Filter.MatrixSize)-1;
end;


procedure TFilterCtrlForm.FormCreate(Sender: TObject);
var i:Integer;
begin
  ResultBitmap:=tBitmap.Create;
  r:=true;
  g:=true;
  b:=true;
  Panel1.Caption:='';
  Panel1.Width:=290;
  Panel1.Height:=245;
  for i:=0 to 48 do
  begin
   EditArray[i]:=TEdit.Create(Panel1);
   EditArray[i].Parent:=Panel1;
   EditArray[i].Width:=30;
   EditArray[i].Height:=21;
   EditArray[i].Left:=((i div 7) * 30)+5;
   EditArray[i].Top:=((i mod 7) * 20)+5;
 //  EditArray[i].OnChange:=EditChanged;
   EditArray[i].Visible:=false;
  end;
  for i:=0 to 48 do ActFilter.Matrix[i div 7,i mod 7]:=0;
  ActFilter.MatrixSize:=mx3;
  ActFilter.Divisor:=1;
  ActFilter.Bias:=0;
  MakeEditFields(ActFilter);

  for i:=1 to 4 do ActTwoPassFilter.Filters[i]:=nil;
  ListBox1.Items.Clear;
  TwoPass.Items.Clear;

  For i:=1 to cnt_predefined_linflt do begin
    ListBox1.Items.AddObject(LinearFilters[i].Filter^.FilterName,@LinearFilters[i].Filter);
    FilterCombo1.Items.Add(LinearFilters[i].Filter^.FilterName);
    FilterCombo2.Items.Add(LinearFilters[i].Filter^.FilterName);
    FilterCombo3.Items.Add(LinearFilters[i].Filter^.FilterName);
    FilterCombo4.Items.Add(LinearFilters[i].Filter^.FilterName);
  end;
  For i:=0 to 10 do begin
    Funct1.Items.Add(Functions[i]);
    Funct2.Items.Add(Functions[i]);
    Funct3.Items.Add(Functions[i]);
  end;
{    ListBox1.Items.Add('Null');
    FilterCombo1.Items.Add('Null');
    FilterCombo2.Items.Add('Null');
    FilterCombo3.Items.Add('Null');
    FilterCombo4.Items.Add('Null');
                                     }
  For i:=1 to cnt_predefined_multipass do TwoPass.Items.Add(TwoPassFilters[i].Filter^.FilterName);


end;

procedure TFilterCtrlForm.EditChanged(Sender: TObject);
var i:Integer;
begin
    ActFilter.Divisor:=StrToInt(MaskEdit1.Text);
    ActFilter.Bias:=StrToInt(MaskEdit2.Text);
   for i:=0 to 48 do ActFilter.Matrix[i div 7,i mod 7]:=StrToInt(EditArray[i].Text);
end;

procedure TFilterCtrlForm.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
  0:  ActFilter.MatrixSize:=mx3;
  1:  ActFilter.MatrixSize:=mx5;
  2:  ActFilter.MatrixSize:=mx7;
  end;
  MakeEditFields(ActFilter);
end;

procedure TFilterCtrlForm.ListBox1Click(Sender: TObject);
var i,j:Integer;
begin
{  Case ListBox1.ItemIndex of
  0: ActFilter:=mxEmbossColor;
  1: ActFilter:=mxEmbossLight;
  2: ActFilter:=mxEmbossMedium;
  3: ActFilter:=mxEmbossDark;
  4: ActFilter:=mxEdgeEnhance;
  5: ActFilter:=mxBlurBartlett;
  6: ActFilter:=mxNegative;
  7: ActFilter:=mxBlur;
  8: ActFilter:=mxBlurSoftly;
  9: ActFilter:=mxBlurMore;
  10:ActFilter:=mxPrewitt;
  11:ActFilter:=mxTraceContour;
 }
  r:=CheckBox1.Checked;
  g:=CheckBox2.Checked;
  b:=CheckBox3.Checked;

  if TwoPass.ItemIndex>-1 then ActTwoPassFilter:= TwoPassFilters[TwoPass.ItemIndex+1].Filter^;
  if ListBox1.ItemIndex>-1 then ActFilter:= LinearFilters[ListBox1.ItemIndex+1].Filter^;
  case ActFilter.FilterType of
  ftStatic:begin
             Panel1.Visible:=false;
           end;
  ftLinear:begin
             Panel1.Visible:=true;
           end;
  end;
  RadioGroup1.ItemIndex:=Integer(ActFilter.MatrixSize)-1;
  for i:=0 to 6 do for j:=0 to 6 do BckMatrix[i,j]:=ActFilter.Matrix[i,j];
  Button1Click(self);
end;

procedure TFilterCtrlForm.Button1Click(Sender: TObject);
//var sz:TMatrixSize;
begin
  if PageControl1.ActivePage=TwoPassSheet then
  begin

    if Assigned(ActTwoPassFilter.Filters[1]) then
    FilterCombo1.Text:=ActTwoPassFilter.Filters[1].FilterName else FilterCombo1.Text:='';

    if Assigned(ActTwoPassFilter.Filters[2]) then
    FilterCombo2.Text:=ActTwoPassFilter.Filters[2].FilterName  else FilterCombo2.Text:='';

    if Assigned(ActTwoPassFilter.Filters[3]) then
    FilterCombo3.Text:=ActTwoPassFilter.Filters[3].FilterName  else FilterCombo3.Text:='';

    if Assigned(ActTwoPassFilter.Filters[4]) then
    FilterCombo4.Text:=ActTwoPassFilter.Filters[4].FilterName  else FilterCombo4.Text:='';

    EffectMultiPass(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,ActTwoPassFilter,NrPass.ItemIndex+2,eMode,r,g,b,false,nil);
  end else
  begin
    if PageControl1.ActivePage=UserSheet then
    begin
      EditChanged(self);
      ActFilter.FilterType:=ftLinear;
    end;
    MakeEditFields(ActFilter);
{    case RadioGroup1.ItemIndex of
    0:sz:=mx3;
    1:sz:=mx5;
    2:sz:=mx7;
    end;


 }
      EffectFilter(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,ActFilter,ActFilter.MatrixSize,eMode,r,g,b,false,nil);

  end;
  PreviewPanel1.PreviewImage.Repaint;
end;

procedure TFilterCtrlForm.FormDestroy(Sender: TObject);
begin
  ResultBitmap.Free;
end;

procedure TFilterCtrlForm.Button3Click(Sender: TObject);
begin
  Screen.Cursor:=crHourGlass;
  CreateXPanel(Self,200,100);
  XPanel.Caption:='Applying Filter...';

  try
    if not PreviewPanel1.SourceBitmap.Empty then
    if PageControl1.ActivePage<>TwoPassSheet then
    EffectFilter(PreviewPanel1.SourceBitmap,ResultBitmap,ActFilter,ActFilter.MatrixSize,eMode,r,g,b,false,XProgress) else
    EffectMultiPass(PreviewPanel1.SourceBitmap,ResultBitmap,ActTwoPassFilter,NrPass.ItemIndex+2,eMode,r,g,b,false,XProgress)
  finally
  Screen.Cursor:=crDefault;
  ReleaseXPanel;
  end;
end;

procedure TFilterCtrlForm.RadioGroup2Click(Sender: TObject);
begin
  case RadioGroup2.ItemIndex of
  0:begin
     CheckBox1.Caption:='Red';
     CheckBox2.Caption:='Green';
     CheckBox3.Caption:='Blue';
     eMode:=csRGB;
    end;
  1:begin
     CheckBox1.Caption:='Hue';
     CheckBox2.Caption:='Saturation';
     CheckBox3.Caption:='Value';
     eMode:=csHSV;
    end;
 2:begin
     CheckBox1.Caption:='Hue';
     CheckBox2.Caption:='Saturation';
     CheckBox3.Caption:='Luminance';
     eMode:=csHSL;
    end;
 end;
 Button1Click(nil);
end;






procedure TFilterCtrlForm.PreviewPanel1OrgPosChanged(Sender: TObject);
begin
  Button1Click(self);
end;



procedure TFilterCtrlForm.FilterCombo2Change(Sender: TObject);
begin
  if (Sender as TComboBox).Text='Null' then
  pGraphicFilter(ActTwoPassFilter.Filters[TComboBox(Sender).Tag]):=@mxZero
  else
  pGraphicFilter(ActTwoPassFilter.Filters[TComboBox(Sender).Tag]):=
  pGraphicFilter(LinearFilters[TComboBox(Sender).ItemIndex].Filter);
  Button1Click(self);
end;

procedure TFilterCtrlForm.Funct1Change(Sender: TObject);
begin
  if (Sender as TComboBox).Text='Null' then
  ActTwoPassFilter.Functions[TComboBox(Sender).Tag]:=gaNone
  else
  ActTwoPassFilter.Functions[TComboBox(Sender).Tag]:=
  TGraphicArithmetic(TComboBox(Sender).ItemIndex);
  Button1Click(self);
end;

procedure TFilterCtrlForm.NrPassClick(Sender: TObject);
begin
  Case NrPass.ItemIndex of
  0:begin
     FilterCombo4.Enabled:=false;
     FilterCombo3.Enabled:=false;
     Funct2.Enabled:=false;
     Funct3.Enabled:=false;
    end;
  1:begin
     Funct3.Enabled:=false;
     Funct2.Enabled:=true;
     FilterCombo3.Enabled:=true;
     FilterCombo4.Enabled:=false;
    end;
  2:begin
     FilterCombo4.Enabled:=true;
     FilterCombo3.Enabled:=true;
     Funct2.Enabled:=True;
     Funct3.Enabled:=True;
    end;
  end;
end;

procedure TFilterCtrlForm.NewLinClick(Sender: TObject);
begin
   PageControl1.ActivePage:=UserSheet;
end;

procedure TFilterCtrlForm.SaveLinClick(Sender: TObject);
begin
   if SaveDialog1.Execute then
   begin
     EditChanged(Self);
    if (ExtractFileExt(SaveDialog1.FileName)='.flf')
     then
     SaveLinearFilterToFile(PCHar(SaveDialog1.FileName),ActFilter) else
     if ExtractFileExt(SaveDialog1.FileName)='.fmf' then
     SaveMultiPassFilterToFile(PCHar(SaveDialog1.FileName),ActTwoPassFilter) else
     raise EGraphicEffects.Create('Illegal filter file');
     MakeEditFields(ActFilter);
   end;
end;

procedure TFilterCtrlForm.RotateMatrix(Steps:Integer);

var hm:TEffectMatrix;
    k,i,j:Integer;

procedure ActualizeMatrix;
var i,j:Integer;
begin
   for i:=0 to 6 do for j:=0 to 6 do
   ActFilter.Matrix[i,j]:=hm[i,j];
end;

procedure Rotate3x3;
  begin
   with ActFilter do begin
    hm[3,3]:=Matrix[3,3];
    hm[2,2]:=Matrix[3,2];
    hm[3,2]:=Matrix[4,2];
    hm[4,2]:=Matrix[4,3];
    hm[4,3]:=Matrix[4,4];
    hm[4,4]:=Matrix[3,4];
    hm[3,4]:=Matrix[2,4];
    hm[2,4]:=Matrix[2,3];
    hm[2,3]:=Matrix[2,2];
   end;
   ActualizeMatrix;
  end;

procedure Rotate5x5;
var  i,j:Integer;
  begin
  with ActFilter do begin
    for i:=1 to 3 do hm[i,1]:=Matrix[i+2,1];
    hm[4,1]:=Matrix[5,2];
    for j:=1 to 3 do hm[5,j]:=MAtrix[5,j+2];
    hm[5,4]:=Matrix[4,5];
    for i:=5 downto 3 do hm[i,5]:=Matrix[i-2,5];
    hm[2,5]:=Matrix[1,4];
    for j:=5 downto 3 do hm[1,j]:=MAtrix[1,j-2];
    hm[1,2]:=Matrix[2,1];
    end;
   ActualizeMatrix;
  end;

procedure Rotate7x7;
var  i,j:Integer;
  begin
  with ActFilter do begin
    for i:=0 to 3 do hm[i,0]:=Matrix[i+3,0];
    hm[4,0]:=Matrix[6,1];
    hm[5,0]:=Matrix[6,2];
    for j:=0 to 3 do hm[6,j]:=MAtrix[6,j+3];
    hm[6,4]:=Matrix[5,6];
    hm[6,5]:=Matrix[4,6];

    for i:=6 downto 3 do hm[i,6]:=Matrix[i-3,6];
    hm[2,6]:=Matrix[0,5];
    hm[1,6]:=Matrix[0,4];
    for j:=6 downto 3 do hm[0,j]:=MAtrix[0,j-3];
    hm[0,2]:=Matrix[1,0];
    hm[0,1]:=Matrix[2,0];
    end;
   ActualizeMatrix;
  end;

begin
 for i:=0 to 6 do for j:=0 to 6 do ActFilter.Matrix[i,j]:=BckMatrix[i,j];
 for i:=0 to 6 do for j:=0 to 6 do hm[i,j]:=BckMatrix[i,j];

if Steps=0 then  ActualizeMatrix else
for k:=0 to Steps-1 do with ActFilter do
 begin
 Rotate3x3;
 case MatrixSize of
 mx5:Rotate5x5;
 mx7:Begin
     Rotate5x5;
     Rotate7x7;
     end;
 end;
 end;
 MakeEditFields(ActFilter);
end;










procedure TFilterCtrlForm.SpeedButton9Click(Sender: TObject);
begin
  RotateMatrix((Sender as TSpeedButton).Tag);
  Button1Click(Self);
end;



procedure TFilterCtrlForm.MirrorTopBotCBClick(Sender: TObject);
begin
  EditChanged(self);
  MakeEditFields(ActFilter);
end;



procedure TFilterCtrlForm.Button5Click(Sender: TObject);
begin
   if OpenDialog1.Execute then
   begin
    if ExtractFileExt(OpenDialog1.FileName)='.flf' then
     LoadLinearFilterFromFile(PCHar(OpenDialog1.FileName),ActFilter) else
    if ExtractFileExt(OpenDialog1.FileName)='.fmf' then
     LoadMultiPassFilterFromFile(PCHar(OpenDialog1.FileName),ActTwoPassFilter) else
     raise EGraphicEffects.Create('Illegal filter file');
     MakeEditFields(ActFilter);
     Button1Click(self);
   end;
end;


end.

